<?php
add_action ('init',create_function('','global $spectacula; $spectacula = new spectaculaTheme();'));

class spectaculaTheme {

	function spectaculaTheme(){

		// Some simple fixes and hacks.
		add_filter('body_class',array($this,'get_agent_body_class'));
		add_action('wp_head',array($this,'extraRSSFeeds'));
		add_action('wp',array($this,'before_headers'));
		// Set max width for post images
		add_action('editor_max_image_size',create_function('','return array(580,0);'));
		add_filter('the_excerpt',array($this,'excerpt_more_link'));

//		add_filter('wp_list_categories',array($this,'category_count_fix'));

		if (function_exists('add_custom_image_header')){
			define("HEADER_TEXTCOLOR","fff");
			define("HEADER_IMAGE","%s/images/logo.png"); // %s is theme dir uri
			define("HEADER_IMAGE_WIDTH", 128);
			define("HEADER_IMAGE_HEIGHT", 128);
			add_custom_image_header('custom_image_head','custom_image_admin_head');
		}

		// If my sometoggles.php is included then lets add some toggles.
		if (function_exists('add_page_toggle') || function_exists('add_post_toggle'))  {
			add_page_toggle(__('Link to this on the tab bar'),'header');
			add_page_toggle(__('Link to this in the footer'), 'footer');
			add_post_toggle(__('Hide the title'), 'hidetitle');
			add_page_toggle(__('Hide the title'), 'hidetitle');
		}

		// Register sidebars
		if ( function_exists('register_sidebar') ) {
		    register_sidebar(array(
				'name' => 'Sidebar',
				'id' => 'sidebar-1',
				'before_widget' => '<div class="widget %2$s" id="%1$s"><span class="widget-top"></span><div class="widget-centre">',
				'after_widget' => '</div><span class="widget-bottom"></span></div>',
				'before_title' => '<h3 class="widgettitle">',
				'after_title' => '</h3>'
			));
		    register_sidebar(array(
				'name' => 'Header Content',
				'id' => 'sidebar-2',
				'before_widget' => '<div id="%1$s" class="header-widget %2$s">',
				'after_widget' => '</div>',
				'before_title' => '<h2 class="widgettitle">',
				'after_title' => '</h2>'
			));
		}
	}

	// Add some jQuery bits to the site.
	function before_headers(){
		global $wp_version;

		if(function_exists('wp_list_comments') && is_singular())
			wp_enqueue_script('comment-reply');

		if (!is_admin() && version_compare($wp_version, '2.5', '>')) { // Only add jQuery to wp 2.5 an above.
			wp_enqueue_script('behaviour',get_bloginfo('template_url').'/js/behaviour.min.js',array('jquery'),1.0);
			wp_localize_script('behaviour','behaviourL10n',array(
				'searchError'	=> __('Oops! Try again.'),
				'searchPrompt'	=> __('Search'),
				'trackbackShowText' => __('Show trackbacks'),
				'trackbackHideText' => __('Hide trackbacks'),
				'replyHideMany' => __("Hide %count% replies to %name% comment"),
				'replyShowMany' => __("View %count% replies to %name% comment"),
				'replyHideOne' => __("Hide the reply to %name% comment"),
				'replyShowOne' => __("View the reply to %name% comment"),
				'nestDepth' => 1 // The depth at which to start collapsing comments.
			));
		}
	}

	// Change the [...] item at the bottom of the excerpt to a more useful link.
	function excerpt_more_link($content = '') {
		$replacement = '<span class="more_link_small"><a href="'.get_permalink().'"> Read more</a></span>';
		$content = str_replace(array('[&#8230;]','[...]'),'&#8230;',$content);
		return $content.$replacement;
	}

	// Move the category count to inside the anchor. Otherwise formatting done on the anchor can be messed up when the option is turned on.
	function category_count_fix($content) {
		$content = preg_replace('/<\/a>[^\(<]*(\(\d*\))/i','&nbsp;&nbsp;<span class="category_count">$1</span></a>',$content);
		return $content;
	}

	// This is in no way comprehensive but does help to ident IE for style sheet hacking.
	function get_agent_body_class($class = array()){
		$useragent = getenv('HTTP_USER_AGENT');

		if(preg_match('!gecko/\d+!i',$useragent))
			$class[] = 'gecko';
		elseif(preg_match('!(applewebkit|konqueror)/[\d\.]+!i',$useragent))
			$class[] = 'webkit';
		elseif (preg_match('!msie\s+(\d+\.\d+)!i',$useragent,$match)) {
			$class[] = 'ie';
			$version = floatval($match[1]);

			/* Add an identifier for IE versions. */
			if ($version >= 9)						array_push($class,'ienew');
			if ($version >= 8 &&	$version < 9)	array_push($class,'ie8');
			if ($version >= 7 &&	$version < 8)	array_push($class,'ie7');
			if ($version >= 6 &&	$version < 7)	array_push($class,'ie6');
			if ($version >= 5.5 &&	$version < 6)	array_push($class,'ie55');
			if ($version >= 5 &&	$version < 5.5)	array_push($class,'ie5');
			if ($version < 5) 						array_push($class,'ieold');
		}

		return $class;
	}

	function extraRSSFeeds() {
		global $post;
		if ((comments_open() || get_comments_number() > 0) && (!is_attachment() && (is_single() || is_page()))) {
		?>	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo("name");echo " &raquo; comments feed";?>" href="<?php echo get_post_comments_feed_link($post->ID);?>"/><?php
		} elseif (is_search()) {
			$search = attribute_escape(get_search_query());
			if (!empty($search))
		?>	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo("name");echo " &raquo; search &quot;".$search."&quot; ";?>" href="<?php echo get_search_feed_link()?>"/><?php
		} elseif(is_category()) {
			global $cat;
		?>	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo("name");echo " &raquo; category &quot;".get_catname($cat)."&quot; ";?>" href="<?php echo get_category_feed_link($cat)?>"/><?php
		} elseif(function_exists('is_tag') && is_tag()) {
			global $tag;
			$term = is_term($tag,"post_tag");
		?>	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo("name");echo " &raquo; tag &quot;$tag&quot; ";?>" href="<?php echo get_tag_feed_link($term["term_id"])?>"/><?php
		}

		return true;
	}
}

/*
 I call this from within the body tag to add a couple of classes to it to help
 me with the CSS in certain browsers, namely IE.
 Seems this function has been added to wp2.8. I've split out the user agent
 sniffing into another function and added that to the new filter.
*/
if (!function_exists('body_class')) {
	function body_class() {
		if (is_page())			$class[] = 'page';
		if (is_home())			$class[] = 'home';
		if (is_single())		$class[] = 'single';
		if (is_category())		$class[] = 'category';
		if (is_author())		$class[] = 'author';
		if (is_search())		$class[] = 'search';
		if (is_date())			$class[] = 'date';
		if (is_year())			$class[] = 'year';
		if (is_month())			$class[] = 'month';
		if (is_day())			$class[] = 'day';
		if (is_time())			$class[] = 'time';
		if (is_404())			$class[] = 'error404';
		if (is_paged())			$class[] = 'paged';
		if (is_attachment())	$class[] = 'attachment';
		if (is_archive() && !is_category()) $class[] = 'archive';

		$class = apply_filters('body_class',$class);

		$class = implode(' ',$class);
		if (!empty($class)) {
			echo " class=\"$class\"";
		}
	}
}

if (!function_exists('get_search_form')) {
	function get_search_form(){
		if (file_exists(TEMPLATEPATH . '/searchform.php'))
			include (TEMPLATEPATH . '/searchform.php');
	}
}

if (!function_exists('navigation_links')) {
	function navigation_links () {
		global $wp_query;
		if ( $wp_query->max_num_pages > 1 && !is_singular()) {
			echo '<div class="post-navigation"><span class="post-navigation-top"></span><div class="post-navigation-links">';
			posts_nav_link();
			echo '</div><span class="post-navigation-bottom"></span></div>';
		}
	}
}

if(!function_exists('oops_text')) {
	function oops_text() {?>
		<div class="post-title"><h2><?php _e("We couldn't find what you were looking for.")?></h2></div>
		<p><br/>
			<b>You have are several options:</b><br/>
			You can go <a href="javascript:history.go(-1)">back</a> from whence you came,
			you can click <a href="<?php bloginfo('home');?>">here</a> to get to the
			landing page of this site. You should see a search box on this page and you
			should also see links down the right side of the page that may fill your requirements.
		</p>
		<?php get_search_form();
	}
}

if (!function_exists('custom_image_admin_head')) {
	function custom_image_admin_head(){?>
	<style type="text/css" media="screen">
	<!--
		#headimg {
			position:relative;
			height: 152px;
			background: no-repeat 12px 12px #000;
			background-color: #000 !important; /* Needed for wp2.2*/
			margin-bottom: 1em;
		}
		#headimg h1 {
			position: absolute;
			top: 12px;
			left: 152px;
			margin: 0;
			padding: 0;
			line-height: 1em;
			font-variant: small-caps;
			font-size: 20pt;
			background-color: #000;
		}
		#headimg #desc{
			position: absolute;
			bottom: 24px;
			padding-left: 12px;
			left: 140px;
			width: 828px;
			background-color: #333;
			line-height: 2em;
		}
		#headimg #desc,
		#headimg h1 a,
		#headimg h1 {
			text-decoration: none;
			border: 0 none;
			font-family: arial,free-sans,sans-serif;
			<?php echo (get_header_textcolor() != "blank" ? "color:#".get_header_textcolor().";":"display:none");?>
		}

	-->
	</style>
	<?php
	}
}

if (!function_exists('custom_image_head')){
	function custom_image_head() {?>
		<style type="text/css" media="screen"><!-- div.tagline h2, h1.main-page-title {<?php echo (get_header_textcolor() != "blank" ? "color:#".get_header_textcolor().";":"display:none");?>} --></style>
		<?php
		$headerImage = get_header_image();
		//If it's a png we're going to have to fix it for anything less than IE7.
		if ($headerImage != "" && preg_match("/\.png$/is",$headerImage)) {
			echo
<<<IEHEADERFIX
\n<!--[if lt IE 7]>\n\t<style type="text/css" media="screen">a#mainlogo img{visibility: hidden}a#mainlogo{filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='$headerImage', sizingMethod='image'}</style>\n<![endif]-->\n
IEHEADERFIX;
		}
	}
}?>